setwd("~/R/VPS_Fuel_Analysis")
pdf(paste0('HFOSGSIN_HK.pdf'))

plotFulePricesWW <- function(){
  #  load('~/R/csv/VPS/FuelPriceHFO380WW.RData') #http://www.bunkerindex.com/prices/bixfree_1712.php?priceindex_id=2
  FuelPriceHFO380      <-  read.csv2("daniel_wu_bix_wwfuelprice_2018-12-20.csv", sep=";", header = T)
  FuelPriceHFO380$Date <-  as.Date(FuelPriceHFO380$Date,format='%d.%m.%Y',tz='UTC')
  names(FuelPriceHFO380)[2] <- 'IFH380_Price'
  
  load('~/R/csv/VPS/rawOilBrentEurope.RData')#https://fred.stlouisfed.org/series/DCOILBRENTEU
  names(oilPrice)[2] <- 'Crude_Price'
  z <- merge(oilPrice,FuelPriceHFO380,by='Date',all=T)
  #z <- z[which(!is.na(z$Price_Bunker_USD)),]
  names(z)[c(2,3)] <-c('Price_Crude_USD','Price_Bunker_USD')
  txt <- paste('Normalized prices: HFO380-Bunker (blue) and Crude oil (Brent Europe, red)')
  
  #normized prices
  plot(FuelPriceHFO380$Date,(FuelPriceHFO380$IFH380_Price-min(FuelPriceHFO380$IFH380_Price,na.rm=T))/max((FuelPriceHFO380$IFH380_Price-min(FuelPriceHFO380$IFH380_Price,na.rm=T)),na.rm=T),pch=19,cex=0.4,t='b',col='blue',main=txt,xlab='',ylab='rel')
  points(oilPrice$Date,(oilPrice$Crude_Price-min(oilPrice$Crude_Price,na.rm=T))/max((oilPrice$Crude_Price-min(oilPrice$Crude_Price,na.rm=T)),na.rm=T),pch=19,cex=0.4,t='b',col='red')
  grid(NULL,NULL)
  maxHFO   <- max(FuelPriceHFO380$IFH380_Price,na.rm=T)
  minHFO   <- min(FuelPriceHFO380$IFH380_Price,na.rm=T)
  
  maxCrude <- max(oilPrice$Crude_Price,na.rm=T)
  minCrude <- min(oilPrice$Crude_Price,na.rm=T)
  mintxt <- paste('Min: HFO=',minHFO,'$','\nCrude=',minCrude,'$',sep='')
  maxtxt <- paste('Max: HFO=',maxHFO,'$','\nCrude=',maxCrude,'$',sep='')
  text(max(FuelPriceHFO380$Date),0.9,maxtxt,adj=1)
  text(min(FuelPriceHFO380$Date),0.1,mintxt,adj=0)
  lines(c(min(FuelPriceHFO380$Date),max(FuelPriceHFO380$Date)),c(1,1),col='grey',lty=2)
  lines(c(min(FuelPriceHFO380$Date),max(FuelPriceHFO380$Date)),c(0,0),col='grey',lty=2)
  
  
  # Bunk vs crude
  txt <- 'Crude vs Bunker prices'
  plot(z$Price_Crude_USD,z$Price_Bunker_USD,pch=19,cex=0.4,t='b',col='orange',main=txt,xlab='Crude [$]',ylab='HFO30 [$]')
  grid(NULL,NULL)
  
  #fraction
  z$fract <- z$Price_Bunker_USD/z$Price_Crude_USD
  txt <- paste('Relationship between Bunker and Crude prices (Bunker$ = factor * Crude$)')
  plot(z$Date,z$fract,pch=19,cex=0.4,t='b',col='skyblue',ylab='Bunker/Crude',xlab='',main=txt)
  grid(NULL,NULL)
  
   return(z)
}
wwprice <- plotFulePricesWW()
bunkerPrice <- function(wwprice){
price_ifo380           <- read.csv("~/R/VPS_Fuel_Analysis/price_ifo380.csv",sep=';')
price_ifo380$Date_hk   <- as.POSIXct(price_ifo380$Date_hk,  format='%d.%m.%Y',tz='UTC')
price_ifo380$Date_sing <- as.POSIXct(price_ifo380$Date_sing,format='%d.%m.%Y',tz='UTC')
 
sing <- price_ifo380[,c(1,2)]; names(sing)<-c('Date','Sing')
hk   <- price_ifo380[,c(3,4)]; names(hk)  <-c('Date','HK')

index <- which(!is.na(sing$Date));sing <- sing[index,]
index <- which(!is.na(sing$Sing));sing <- sing[index,]

index <- which(!is.na(hk$Date));hk <- hk[index,]
index <- which(!is.na(hk$HK));  hk <- hk[index,]

price       <- merge(sing,hk,by='Date')
price$Date  <- as.Date(price$Date)
price       <- merge(price,wwprice,by='Date',all=T)
price$delta <- price$HK-price$Sing

plot(price$Date,price$HK,main='HK (black), Sing (blue), WW (orange) IFO price',ylab='$',xlab='',t='b',pch=19,cex=0.3);grid(NULL,NULL)
points(price$Date,price$Sing,t='b',pch=19,cex=0.3,col='blue')
points(price$Date,price$Price_Bunker_USD,t='b',pch=19,cex=0.3,col='orange')

price$WWSG <- price$Price_Bunker_USD-price$Sing
price$WWHK <- price$Price_Bunker_USD-price$HK
plot(price$Date,price$WWSG,t='b',pch=19,cex=.4,col='blue',ylab='diff in $',
     ylim=range(price$WWSG,price$WWHK,na.rm=T),main='Price difference WW-SG (blue) and WW-HK (orange)')
points(price$Date,price$WWHK,t='b',pch=19,cex=.4,col='orange')
grid(NULL,NULL)

plot(price$Date[price$Date>'2017-01-01'],price$WWSG[price$Date>'2017-01-01'],t='b',pch=19,cex=.4,ylab='diff in $',col='blue',ylim=range(price$WWSG[price$Date>'2017-01-01'],price$WWHK[price$Date>'2017-01-01'],na.rm=T),main='Price difference WW-SG (blue) and WW-HK (orange)')
points(price$Date[price$Date>'2017-01-01'],price$WWHK[price$Date>'2017-01-01'],t='b',pch=19,cex=.4,col='orange')
grid(NULL,NULL)

price$diffHKSG <- price$WWHK-price$WWSG
plot(price$Date[price$Date>'2017-01-01'],price$diffHKSG[price$Date>'2017-01-01'],t='b',pch=19,cex=.4,ylab='diff in $',col='blue',main='(WW-HK) - (WW-SG)')
abline(0,0,col='red',lty=2)
grid(NULL,NULL)


plot(price$Date,price$delta,main='HK-Sing price difference',ylab='$',xlab='',t='b',pch=19,cex=0.3,col='blue');grid(NULL,NULL)
abline(0,0,col='red')

par(mfrow=c(1,2))
i_const <- which(price$Date>='2013-04-15' & price$Date<'2014-08-01' & !is.na(price$delta))
plot(price$Date[i_const],price$Sing[i_const],t='b',pch=19,cex=0.3,col='blue',ylab='price in SGSIN [$]',main='Near constant price regime');grid(NULL,NULL);abline(0,0)

plot(price$Date[i_const],price$delta[i_const],t='b',pch=19,cex=0.3,col='blue',ylab='price diff [$]',main='Near constant price regime');grid(NULL,NULL);abline(0,0)
z <- lm(price$delta[i_const] ~ price$Date[i_const])
lines(price$Date[i_const],fitted(z),col='red',lty=2)
summary(z)
par(mfrow=c(1,1))


par(mfrow=c(1,2))
i_decrease <- which(price$Date>='2014-09-01' & price$Date<'2016-01-01' & !is.na(price$delta))
plot(price$Date[i_decrease],price$Sing[i_decrease],t='b',pch=19,cex=0.3,col='blue',ylab='price in SGSIN [$]',main='Decreasing price regime');grid(NULL,NULL);abline(0,0)
plot(price$Date[i_decrease],price$delta[i_decrease],t='b',pch=19,cex=0.3,col='blue',ylab='price diff [$]',main='Decreasing price regime');grid(NULL,NULL);abline(0,0)
z <- lm(price$delta[i_decrease] ~ price$Date[i_decrease])
lines(price$Date[i_decrease],fitted(z),col='darkgreen',lty=2)
summary(z)
par(mfrow=c(1,1))
d <-price$delta[i_decrease]  - fitted(lm(price$delta[i_decrease] ~ price$Date[i_decrease]))
p <- price$Sing[i_decrease] - fitted(lm(price$Sing[i_decrease] ~ price$Date[i_decrease]))


par(mfrow=c(1,2))
i_increase <- which(price$Date>='2016-01-01' & !is.na(price$Sing))
plot(price$Date[i_increase],price$Sing[i_increase],t='b',pch=19,cex=0.3,col='blue',ylab='price  [$]',main='Increasing price regime');grid(NULL,NULL);abline(0,0)
plot(price$Date[i_increase],price$delta[i_increase],t='b',pch=19,cex=0.3,col='blue',ylab='price  [$]',main='Increasing price regime');grid(NULL,NULL);abline(0,0)
z <- lm(price$delta[i_increase] ~ price$Date[i_increase])
lines(price$Date[i_increase],fitted(z),col='red',lty=2)
summary(z)
par(mfrow=c(1,1))



return(price)
}
price <- bunkerPrice(wwprice)


HFO380_SGSIN <- read.csv("HFO380_SGSIN.csv",stringsAsFactors = F)
HFO380_HKHKG <- read.csv("HFO380_HKHKG.csv",stringsAsFactors = F)

#delta - density
Fuel_comparison <- function(Fuel,dRange =c(988,991),txt='XXX',txtparameter='deltaDensity', H1='dd_is_less'){
  deltaDens_com <- function(Fuel, densityRange =c(989.5,989.6),para =txtparameter){
    i_post  <- which(Fuel$Date >='2017-01-01' )
    i_pre   <- which(Fuel$Date < '2016-01-01' )
    d_post  <- Fuel$density[i_post]
    d_pre   <- Fuel$density[i_pre ]
    dd_post <- Fuel[i_post,which(names(Fuel)== para)]
    dd_pre  <- Fuel[i_pre, which(names(Fuel)== para)]
    x <- data.frame(d=c(d_pre,d_post),dd=c(dd_pre,dd_post), ind=c(rep('pre',length(dd_pre)),rep('post',length(dd_post)) ))
    x <- x[order(x$d),] 
    x <- x[which(!is.na(x$d)),]
    x <- x[which(!is.na(x$dd)),]
    
    y <- x[which(x$d> densityRange[1] & x$d<=densityRange[2]),]
    dd_pre   <- y$dd[y$ind=='pre']
    dd_post  <- y$dd[y$ind=='post']
    n_pre    <- length(dd_pre)
    n_post   <- length(dd_post)
    
    m_pre  <- mean(dd_pre)
    m_post <- mean(dd_post)
    
    sd_pre  <- sd(dd_pre)
    sd_post <- sd(dd_post)
   # m             <- m_post-m_pre
   # conf_interval <- c(round(m + 1.96*sqrt(sd_pre^2/n_pre+sd_pre^2/n_post),3),round(m - 1.96*sqrt(sd_pre^2/n_pre+sd_pre^2/n_post),3))
   # conf_interval <- sort(conf_interval)
    tTest         <- t.test(dd_post, dd_pre)
    conf_interval <- tTest$conf.int
    m <- diff(rev(tTest$estimate))
    
    # wilcoxson test of difference in mean
    if(H1=='dd_is_less') H1='less' else if(H1=='dd_is_greater') H1='greater' else H1="two.sided"
    dat    <- data.frame( allData = c(dd_post,dd_pre), dataClasses = c(rep("post",length(dd_post)),rep("pre",length(dd_pre))) )
   if(sd_pre==0 & sd_post==0){
     W_diffInDD   <- round(m_post-m_pre,3)
     W_confInt    <- rep(W_diffInDD,2)
   }else{
     W      <- stats::wilcox.test(allData ~ dataClasses, data = dat,conf.int = T, correct = T, exact = F, conf.level = .95)#,alternative =H1) 
    W_diffInDD   <- round(W$estimate,3)
    W_confInt    <- round(W$conf.int,3)
   }
    
    #variance test
    p_homogenVarianceTest <-   fligner.test(x=y$dd,g=y$ind)$p.value #http://www.sthda.com/english/wiki/compare-multiple-sample-variances-in-r
    var_post__var_pre     <-   sd_post-sd_pre
    
    #Normality test
    if(sd_pre==0 & sd_post==0){
      p_shapiroNorm_pre <- 1
      p_shapiroNorm_post <-1
    }else{
    p_shapiroNorm_pre     <-   shapiro.test(y$dd[y$ind=='pre' ])$p.value #http://www.sthda.com/english/wiki/normality-test-in-r
    p_shapiroNorm_post    <-   shapiro.test(dd_post)$p.value
    }
   
    if(length(grep('REPORT',para)==1)){
      p_pre      <- length(which(dd_pre  >0.1))/n_pre
      p_post     <- length(which(dd_post >0.1))/n_post
      p_diffConf <- 1.96*sqrt(p_pre*(1-p_pre)/n_pre + p_post*(1-p_post)/n_post )
      
      p_diff     <- p_post-p_pre
      p_pooled <- ( length(which(dd_pre  >0.1)) + length(which(dd_post >0.1)) )/(n_pre+n_post)
      Z <- (p_diff)/(sqrt(p_pooled*(1-p_pooled))*sqrt(1/n_pre +1/n_post))
      if(is.nan(Z)) Z <- 0
      #http://www.sthda.com/english/wiki/two-proportions-z-test-in-r
      fract_diff   <- p_diff
      
    }else{
      fract_diff   <- NULL
      p_diffConf   <- NULL
    }
     
     conf_interval <- c(m,conf_interval,fract_diff,p_diffConf,W_diffInDD,W_confInt,p_homogenVarianceTest,var_post__var_pre,p_shapiroNorm_pre,p_shapiroNorm_post)
    
      return(conf_interval)
  }

  Fuel$density      <- as.numeric(Fuel$density)
  Fuel$deltaDensity <- as.numeric(Fuel$deltaDensity)
  
  
  
  #NAive approach in dd
  preDD  <- na.omit(Fuel$deltaDensity[Fuel$Date<'2016-01-01'& Fuel$deltaDensity>-2 & Fuel$deltaDensity<6] )
  postDD <- na.omit(Fuel$deltaDensity[Fuel$Date>='2017-01-01'& Fuel$deltaDensity>-10& Fuel$deltaDensity<6])
  pred   <- density(preDD)
  postd  <- density(postDD)
  plot(pred, col='blue',lwd=2,ylab='',main=paste0(txt,': Density difference \npost(>=2017, red) and pre(<2016, blue)'),xlab='density difference [kg/m^3]')
  #polygon(pred, col="red", border="blue")
  lines(postd,col='red',lwd=2)
  #polygon(postd, col="green", border="blue")
  lines(c(0,0),c(0,1),lty=2,col='black')
  grid(NULL,NULL)
  
  print('Naive approach: Using ALL data')
  tTest <- t.test(preDD,postDD,var.equal = F)
  names(tTest$estimate) <- c('meanDD_pre','meanDD_post')
  print(tTest)
  if(tTest$p.value < 0.05){
    print('Naive approach (all data): H0: rejected, i.e. there IS a difference in deltaDensity')
    #estimate_x = preDD estimate_y =postDD
    if((tTest$estimate[1]-tTest$estimate[2]) > 0) H1<-"greater" else H1<-"less"  #post-pre
    tTest <- t.test(preDD,postDD,var.equal = F,alternative =  H1) 
    if(tTest$p.value < 0.05){
      names(tTest$estimate) <- c('meanDD_pre','meanDD_post')
      print(tTest)
      print(paste0('Mean-density-difference for <2016 is significantly (at 95% conf) ',H1,' than after 2017.'))
    }
    
    }else print('Naive approach (all data): H0: NOT rejected, i.e. there is NO difference in deltaDensity')
  
 
  
  #Naive approach change in nr of SL samples
  if(length(grep('REPORT', txtparameter))==1){
    print('')
    print('Naive approach: Using ALL data')
    
    preSL  <- Fuel[which(!is.na(Fuel$REPORT_SHORT_LIFT_BENCHMARK) & Fuel$Date<'2016-01-01'),]
    postSL <- Fuel[which(!is.na(Fuel$REPORT_SHORT_LIFT_BENCHMARK) & Fuel$Date>='2017-01-01'),]
    
    p_pre  <- length(which(preSL$REPORT_SHORT_LIFT_BENCHMARK  >0.1))/nrow(preSL)
    p_post <- length(which(postSL$REPORT_SHORT_LIFT_BENCHMARK >0.1))/nrow(postSL)
    p_diff <- p_post-p_pre
    p_diffConf <- 1.96*sqrt(p_pre*(1-p_pre)/nrow(preSL) + p_post*(1-p_post)/nrow(postSL) )
    print(paste('Difference in fract. of SL samples (post-pre): ',round(p_diff,3) ,', [',round(p_diff - p_diffConf ,3),',', round(p_diff + p_diffConf ,3),'] = 95% conf. interval'))
    print('If conf.intervals contains 0 => no signif. difference in fraction of SL (at 95% level)')
    ci       <- c(p_diff - p_diffConf,p_diff + p_diffConf)
    signDiff <- sum(sign(ci))*prod(ci)
    
    if(signDiff!=0){
      p_pooled <- (length(which(preSL$REPORT_SHORT_LIFT_BENCHMARK >0.1)) + length(which(postSL$REPORT_SHORT_LIFT_BENCHMARK>0.1)))/(nrow(preSL)+nrow(postSL))
      Z        <- p_diff/(sqrt(p_pooled*(1-p_pooled))*sqrt(1/nrow(preSL) +1/nrow(postSL)))
          if(abs(Z) < 1.64){
            print(paste('Naive approach (all data): No significant difference (',round(p_diff,3),') in fraction,of SL-BM between post and pre at 95% confidence'))
            }else print(paste('Naive approach (all data): Significant difference (',round(p_diff,3), ') in fraction of SL-BM between post and pre at 95% confidence')) 
    }

    
    
#http://www.sthda.com/english/wiki/two-proportions-z-test-in-r
  }
  
 
  #Density distribution all data
  preDD  <- na.omit(Fuel$density[Fuel$Date<'2016-01-01'] )
  postDD <- na.omit(Fuel$density[Fuel$Date>='2017-01-01'])
  pred   <- density(preDD)
  postd  <- density(postDD)
  plot(pred, col='blue',lwd=2,main=paste0(txt,': HFO380 Fuel Density \npre(<2016, blue) and post(>=2017, red)'),xlab='Fuel density [kg/m^3]',ylab='')
  #polygon(pred, col="red", border="blue")
  lines(postd,col='red',lwd=2)
  #polygon(postd, col="green", border="blue")
  lines(c(0,0),c(0,1),lty=2,col='black')
  grid(NULL,NULL)
  
  
  
   
  #restrict to bins with highnumber of samples
  Fuel              <- Fuel[Fuel$density > dRange[1] & Fuel$density <= dRange[2] ,]
  #Fuel density plot
  bin    <- seq(dRange[1],dRange[2],0.1)
  h_pre  <- hist(Fuel$density[Fuel$Date<'2016-01-01'],breaks = bin,
                 main=paste(txt,': Density in kg/m^3'),xlab='density [kg/m^3]',xlim=range(bin),col='skyblue',freq = F,plot=F)
  h_post <- hist(Fuel$density[Fuel$Date>='2017-01-01'],breaks = bin,xlim=range(bin),add=T,freq = F,plot=F)
  z_pre   <- data.frame(binEnd=h_pre$breaks[-1],Density = h_pre$density,  farge=rep('skyblue'),stringsAsFactors = F)
  z_post  <- data.frame(binEnd=h_pre$breaks[-1],Density = h_post$density, farge=rep('orange'), stringsAsFactors = F)
  z       <- rbind(z_pre,z_post)
  z       <- z[order(z$Density,decreasing = T),]
  z       <- z[order(z$binEnd, decreasing = F),]
  bp <- barplot(z$Density[seq(1,nrow(z),2)]*0.1,col=z$farge[seq(1,nrow(z),2)],main=paste(txt,': Density in kg/m^3 (non-stacked)\n blue: <=2015, orange: >= 2017'),
                xlab='',names.arg = z$binEnd[seq(1,nrow(z),2)],las=3)
  bp <- barplot(z$Density[seq(2,nrow(z),2)]*0.1,col=z$farge[seq(2,nrow(z),2)],add=T)
  grid(NULL,NULL)
  text(bp[1],0.05,'influx of lighter fuel \nafter 2017-01-01',adj=0)

  
 
  
  #**********************************  
  result <- NULL
  for(i in 1:(length(bin)-1)) result <- rbind(result, c(bin[i],bin[i+1],deltaDens_com(Fuel,densityRange =c(bin[i],bin[i+1]),para =txtparameter)))
  result        <- data.frame(result)
  if(length(grep('REPORT', txtparameter))==1){
        names(result) <- c('densFrom','densTo','meanDiff','lowConfInt','highConfInt','fract_diff','p_diffConf','W_diffInDD','W_lowconfInt','W_highconfInt','homoVar_p','var_post__var_pre','p_shapiroNorm_pre','p_shapiroNorm_post')
  }else names(result) <- c('densFrom','densTo','meanDiff','lowConfInt','highConfInt','W_diffInDD','W_lowconfInt','W_highconfInt','homoVar_p','var_post__var_pre','p_shapiroNorm_pre','p_shapiroNorm_post')
 for(i in 1:nrow(result))for(j in 1:ncol(result))if(is.nan(result[i,j])) result[i,j] <- NA
 #***************************************
 
  
    #difference in number of samples
  if(length(grep('REPORT', txtparameter))==1){
    signMeanDiff <- (sign(result$fract_diff- result$p_diffConf)+sign(result$fract_diff+ result$p_diffConf))/2
    farge <- rep('grey',nrow(result)) 
    i     <- which(signMeanDiff>0);if(length(i)>0)farge[i]<-'forestgreen'
    i     <- which(signMeanDiff<0);if(length(i)>0)farge[i]<-'red'
      bp<- barplot(result$fract_diff,col=farge,ylab='difference in fraction',main=paste0(txt,': Difference in fraction of ocurrence of \n',txtparameter,'>0.1 between post(>=2017) and pre(<2016)'))
    grid(NULL,NULL)
    arrows(x0 = bp, 
           y0 = result$fract_diff- result$p_diffConf,
           x1 = bp,
           y1 = result$fract_diff+ result$p_diffConf,
           lwd= 1.5,angle=90,code=3,length=0.05,col='blue')
  }
  
  #Normal based conf interval
  result$signMeanDiff <- (sign(result$lowConfInt)+sign(result$highConfInt))/2
  farge <- rep('grey',nrow(result))
  i     <- which(result$signMeanDiff>0);if(length(i)>0)farge[i]<-'forestgreen'
  i     <- which(result$signMeanDiff<0);if(length(i)>0)farge[i]<-'red'
  
  bp <- barplot(result$meanDiff,col=farge,names.arg =bin[-1],las=3,ylab='diffference in mean',xlab='',ylim=range(result$lowConfInt,result$highConfInt,na.rm=T),
                main=paste0('Difference in mean ',txtparameter,' for ',txt,' based on t-test \nbetween post (>2017) and pre (<2016), grey= non-signif. (@ 5%level)'))
  points(bp,result$meanDiff,pch=19,cex=0.4,col=farge)
  grid(NULL,NULL)
  arrows(x0 = bp, 
         y0 = result$lowConfInt,
         x1 = bp,
         y1 = result$highConfInt,
         lwd= 1.5,angle=90,code=3,length=0.05,col='blue')
  
  #wilcoxson based densdiff estimate
  signMeanDiff <- (sign(result$W_lowconfInt)+sign(result$W_highconfInt))/2
  farge <- rep('grey',nrow(result))
  i     <- which(signMeanDiff>0);if(length(i)>0)farge[i]<-'forestgreen'
  i     <- which(signMeanDiff<0);if(length(i)>0)farge[i]<-'red'
  bp <- barplot(result$W_diffInDD,col=farge,names.arg =bin[-1],las=3,ylab='difference in mean',xlab='',ylim=range(result$W_lowconfInt,result$W_highconfInt),
                main=paste0('Difference in mean ',txtparameter,' for ',txt,' based on Wilcinson test \nbetween post (>2017) and pre (<2016), grey= non-signif. (@ 5%level)'))
  points(bp,result$W_diffInDD,pch=19,cex=0.4,col=farge)
  grid(NULL,NULL)
  arrows(x0 = bp, 
         y0 = result$W_lowconfInt,
         x1 = bp,
         y1 = result$W_highconfInt,
         lwd= 1.5,angle=90,code=3,length=0.05,col='blue')
  
  
  
  par(mfrow=c(3,1))
  #Normality test of data per bin based on Shapiro testen
  farge <- rep('grey',nrow(result))
  i  <- which(result$p_shapiroNorm_pre < 0.05);if(length(i)>0) farge[i]<-'red'
  bp <- barplot(result$p_shapiroNorm_pre,col=farge,main=paste0(txt,': Shapiro test for H0: normality in ',txtparameter,' < 2016 \n if p< 0.05 (red) => not normal distributed'),
                names.arg =bin[-1],las=3,ylab='p-value',xlab='' )
  points(bp,result$p_shapiroNorm_pre,pch=19,cex=0.4,col=farge)
  if(length(i)>0) text(bp[i],0.05, round(result$p_shapiroNorm_pre[i],3),col='red',srt=90,adj=0)
  abline(0.05,0,col='red',lty=2)
  
  #Normality test of data per bin based on Shapiro testen
  farge <- rep('grey',nrow(result))
  i     <- which(result$p_shapiroNorm_post < 0.05)
  if(length(i)>0) farge[i]<-'red'
  barplot(result$p_shapiroNorm_post,col=farge,main="Shapiro-Wilk Test (Normality): Hong Kong",
          names.arg =bin[-1],las=3,ylab='p-value',xlab='' )
  points(bp,result$p_shapiroNorm_post,pch=19,cex=0.4,col=farge)
  if(length(i)>0) text(bp[i],0.05, round(result$p_shapiroNorm_post[i],3),col='red',srt=90,adj=0)
  abline(0.05,0,col='red',lty=2)
  
  #Test of same variance data per bin based on fligner testen
  farge <- rep('grey',nrow(result))
  i     <- which(result$homoVar_p < 0.05)
  if(length(i)>0) farge[i]<-'red'
  bp <- barplot(sign(result$var_post__var_pre),col=farge,main=paste0(txt,': Fligner test for H0: same variance (var_post - var_pre = 0) in ',txtparameter,'\n if p< 0.05 (red) => not same variance'),
                names.arg =bin[-1],las=3,ylab='var_post - var_pre',xlab='density bin')
  points(bp,result$var_post__var_pre,pch=19,cex=0.4,col=farge)
  if(length(i)>0) text(bp[i],0.05, round(result$homoVar_p[i],3),col='black',srt=90,adj=0)
  abline(0.05,0,col='red',lty=2)
  
  par(mfrow=c(1,1))
  
  return(result)
}

rSGSIN <- Fuel_comparison(HFO380_SGSIN,txt='SGSIN',txtparameter='deltaDensity')
rHKHKG <- Fuel_comparison(HFO380_HKHKG,txt='HKHKG',txtparameter='deltaDensity')


#shortliftingBM
rSGSIN <- Fuel_comparison(HFO380_SGSIN,txt='SGSIN',txtparameter='REPORT_SHORT_LIFT_BENCHMARK')
rHKHKG <- Fuel_comparison(HFO380_HKHKG,txt='HKHKG',txtparameter='REPORT_SHORT_LIFT_BENCHMARK')

rSGSIN <- Fuel_comparison(HFO380_SGSIN,txt='SGSIN',txtparameter='REPORT_MAX_SHORT_BENCHMARK')
rHKHKG <- Fuel_comparison(HFO380_HKHKG,txt='HKHKG',txtparameter='REPORT_MAX_SHORT_BENCHMARK')
dev.off()